#include<bits/stdc++.h>
using namespace std;
ifstream fi("BAI5a.inp");
ofstream fo("BAI5a.out");
int dx(string s){
   string t,t2;
   int l=s.length();
   t=s.substr(0,l/2+l%2);
   for(int i=l-1;i>=l/2;--i)t2=t2+s[i];
   return (t==t2);
}
int main(){
   string s,ans;
   int c=0;
   std::getline(fi,s);
   if(dx(s)){fo<<"s la xau doi xung";return 0;}
   for(int i=0;i<s.length();++i){
      for(int j=s.length()-i;j>=1;--j){
            string t=s.substr(i,j);
            if(dx(t)&&t.length()>c){ans=t;c=t.length();break;}
      }
   }
   fo<<ans;
 }
